SystemOrganization addCategory: #SystemAnnouncements!

!ReorganizedEvent methodsFor: '*SystemAnnouncements' stamp: 'StephaneDucasse 7/15/2010 23:19'!
category

	^self itemCategory! !

Announcement subclass: #SystemAnnouncement
	instanceVariableNames: 'event'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

!SystemAnnouncement commentStamp: '<historical>' prior: 0!
The root announcement for the events coming from the Pharo system.

Currently, it wraps the event that comes from the SystemChangeNotifier.!

!SystemAnnouncement methodsFor: 'accessing' stamp: 'tg 6/5/2010 12:17'!
event
	^ event! !

!SystemAnnouncement methodsFor: 'accessing' stamp: 'tg 6/5/2010 12:17'!
event: anObject
	event := anObject! !

SystemAnnouncement subclass: #SystemCategoryAddedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

SystemAnnouncement subclass: #SystemCategoryRemovedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

SystemAnnouncement subclass: #SystemClassAddedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

SystemAnnouncement subclass: #SystemClassRemovedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

SystemAnnouncement subclass: #SystemMethodAddedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

!SystemMethodAddedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 7/16/2010 13:08'!
itemClass

	^ event itemClass
	! !

!SystemMethodAddedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 7/16/2010 13:08'!
itemProtocol

	^ event itemProtocol! !

!SystemMethodAddedAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 7/16/2010 13:08'!
itemSelector

	^ event itemSelector
	! !

SystemAnnouncement subclass: #SystemMethodRemovedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

SystemAnnouncement subclass: #SystemProtocolAddedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

SystemAnnouncement subclass: #SystemProtocolRemovedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

TestCase subclass: #SACategoryAnnouncementTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

!SACategoryAnnouncementTest methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 7/6/2010 11:26'!
testAddedCategory
	"self debug: #testAddedCategory"
	| addedCount addedCat | 
	[
		addedCount := 0.
		SystemAnnouncer initialize.
		SystemAnnouncer categoryAnnouncer when: SystemCategoryAddedAnnouncement do: [ :ann | 
			addedCount := addedCount + 1. 
			addedCat := ann event item].
		Smalltalk organization addCategory: 'XXXXX'.
		self assert: addedCat = 'XXXXX'.
		self assert: addedCount = 1.
	] ensure: [
		SystemAnnouncer categoryAnnouncer unsubscribe: self.
		Smalltalk organization removeCategory: 'XXXXX' ]! !

!SACategoryAnnouncementTest methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 7/4/2010 22:27'!
testRemovedCategory
	| count addedCat | 
	[
		count := 0.
		addedCat := ''.
		SystemAnnouncer initialize.
		Smalltalk organization addCategory: 'XXXXX'.
		SystemAnnouncer categoryAnnouncer when: SystemCategoryRemovedAnnouncement do: [ :ann | 
			count := count + 1 ].
		Smalltalk organization removeCategory: 'XXXXX' .
		self assert: count = 1.
	] ensure: [
		SystemAnnouncer categoryAnnouncer unsubscribe: self ]! !

TestCase subclass: #SAClassAnnouncementTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

!SAClassAnnouncementTest methodsFor: 'as yet unclassified' stamp: 'tg 6/13/2010 14:22'!
testAddedClass
	| count | 
	[
		count := 0.
		SystemAnnouncer initialize.
		Object subclass: #XXXX.
		SystemAnnouncer classAnnouncer when: SystemClassRemovedAnnouncement do: [ :ann | 
			count := count + 1. ].
		(Smalltalk at: #XXXX) theNonMetaClass removeFromSystem.
		self assert: count = 1.
	] ensure: [
		SystemAnnouncer classAnnouncer unsubscribe: self ]! !

!SAClassAnnouncementTest methodsFor: 'as yet unclassified' stamp: 'tg 6/13/2010 14:21'!
testRemovedCategory
	| count | 
	[
		count := 0.
		SystemAnnouncer initialize.
		Smalltalk organization addCategory: 'XXXXX'.
		SystemAnnouncer categoryAnnouncer when: SystemCategoryRemovedAnnouncement do: [ :ann | 
			count := count + 1 ].
		Smalltalk organization removeCategory: 'XXXXX' .
		self assert: count = 1.
	] ensure: [
		SystemAnnouncer categoryAnnouncer unsubscribe: self ]! !

TestCase subclass: #SAMethodAnnouncementTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

!SAMethodAnnouncementTest methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 7/16/2010 13:09'!
testAddedMethod
	"self debug: #testAddedMethod"
	| count protocol selector class | 
	[
		count := 0.
		SystemAnnouncer initialize.
		Object subclass: #XXXX.
		SystemAnnouncer methodAnnouncer when: SystemMethodAddedAnnouncement do: [ :ann | 
			count := count + 1. 
			protocol := ann  itemProtocol.
			selector := ann itemSelector.
			class := ann itemClass].
		(Smalltalk at: #XXXX) compile: 'm ^ 1' classified: 'protocol'.
		self assert: count = 1.
		self assert: protocol = 'protocol'.
		self assert: selector = #m.
		self assert: class = (Smalltalk at: #XXXX).
	] ensure: [
		SystemAnnouncer classAnnouncer unsubscribe: self.
		(Smalltalk at: #XXXX) theNonMetaClass removeFromSystem ]! !

!SAMethodAnnouncementTest methodsFor: 'as yet unclassified' stamp: 'tg 6/13/2010 15:25'!
testRemovedMethod
	| count | 
	[
		count := 0.
		SystemAnnouncer initialize.
		Object subclass: #XXXX.
		(Smalltalk at: #XXXX) compile: 'm ^ 1' classified: 'protocol'.
		SystemAnnouncer methodAnnouncer when: SystemMethodRemovedAnnouncement do: [ :ann | 
			count := count + 1. ].
		(Smalltalk at: #XXXX) removeSelector: #m.
		self assert: count = 1.
	] ensure: [
		SystemAnnouncer classAnnouncer unsubscribe: self.
		(Smalltalk at: #XXXX) theNonMetaClass removeFromSystem ]! !

TestCase subclass: #SAProtocolAnnouncementTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

!SAProtocolAnnouncementTest commentStamp: '<historical>' prior: 0!
For now Protocol addition is not well managed at the level of SystemChangeNotifier so we will not cover it.

We will cover it via method modification!

!SAProtocolAnnouncementTest methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 7/16/2010 12:43'!
expectedFailures 

	^ #(testAddedProtocol)! !

!SAProtocolAnnouncementTest methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 7/16/2010 11:11'!
testAddedProtocol
	"self debug: #testAddedProtocol"
	| addedCount protocol | 
	[
		addedCount := 0.
		SystemAnnouncer initialize.
		SystemAnnouncer protocolAnnouncer when: SystemProtocolAddedAnnouncement do: [ :ann | 
			addedCount := addedCount + 1.
			protocol := ann event item ].
		SAProtocolAnnouncementTest organization addCategory: 'protocol - addition'.
		self assert: addedCount = 1.
		self assert: protocol = 'protocol - addition'.
	] ensure: [
		SystemAnnouncer protocolAnnouncer unsubscribe: self.
		SAProtocolAnnouncementTest organization removeCategory: 'protocol - addition' ]! !

Announcer subclass: #SystemAnnouncer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemAnnouncements'!

SystemAnnouncer class
	instanceVariableNames: 'announcer categoryAnnouncer classAnnouncer protocolAnnouncer methodAnnouncer expressionAnnouncer'!

!SystemAnnouncer commentStamp: '<historical>' prior: 0!
This class plays the role of the announcer for events raised by the Pharo system.

Currently, it acts as a wrapper over the SystemChangeNotifier, but in the future it should be used for announcing the events directly from the system.!

SystemAnnouncer class
	instanceVariableNames: 'announcer categoryAnnouncer classAnnouncer protocolAnnouncer methodAnnouncer expressionAnnouncer'!

!SystemAnnouncer class methodsFor: 'private' stamp: 'StephaneDucasse 7/15/2010 22:42'!
announceFromEvent: aChangeEvent
	"This method creates an announcement from a given Event (subclass of AbstractEvent) and announces it.
	
	For example, from an AddedEvent that concerns a class the method creates SystemAddedClassAnnouncement and then it will announce it both from the generic announcer and from the classAnnouncer "
	| announcement itemKindName eventKindName announcementClassName announcementClass specificAnnouncer |
	
	"aChangeEvent isAdded ifTrue: [self halt]."
	"aChangeEvent isModified ifTrue: [self halt]."
	
	aChangeEvent isReorganized 
		ifTrue: ["when you add a new category apparently this is this event"
				announcement := SystemProtocolAddedAnnouncement  new event: aChangeEvent.
				announcer announce: announcement.
				protocolAnnouncer announce: announcement.
			^ self].
	itemKindName := aChangeEvent itemKind.
	eventKindName := (aChangeEvent class name endsWith: 'Event') 
		ifTrue: [ aChangeEvent class name copyFrom: 1 to: aChangeEvent class name size - 'Event' size ] 
		ifFalse: [ aChangeEvent class name ].
	announcementClassName := 	(
										'System', 
										itemKindName capitalized, 
										eventKindName,
										'Announcement'
									) asSymbol.
	announcementClass := Smalltalk at: announcementClassName ifAbsent: [nil].
	announcementClass notNil ifTrue: [
		announcement := announcementClass new event: aChangeEvent.
		announcer announce: announcement.
		specificAnnouncer := self perform: (itemKindName, 'Announcer') asSymbol.
		specificAnnouncer announce: announcement
	]! !

!SystemAnnouncer class methodsFor: 'accessing' stamp: 'lr 2/22/2010 11:17'!
announcer
	"Answer a system annoncer."
	
	^ announcer! !

!SystemAnnouncer class methodsFor: 'accessing' stamp: 'lr 2/22/2010 11:13'!
categoryAnnouncer
	"Answer a category annoncer."
	
	^ categoryAnnouncer! !

!SystemAnnouncer class methodsFor: 'accessing' stamp: 'lr 2/22/2010 11:13'!
classAnnouncer
	"Answer a class annoncer."
	
	^ classAnnouncer! !

!SystemAnnouncer class methodsFor: 'accessing' stamp: 'lr 2/22/2010 11:14'!
expressionAnnouncer
	"Answer a expression annoncer."
	
	^ expressionAnnouncer! !

!SystemAnnouncer class methodsFor: 'initialization' stamp: 'tg 6/13/2010 14:52'!
initialize
	announcer := Announcer new.
	categoryAnnouncer := Announcer new.
	classAnnouncer := Announcer new.
	protocolAnnouncer := Announcer new.
	methodAnnouncer := Announcer new.
	expressionAnnouncer := Announcer new.
	SystemChangeNotifier uniqueInstance 
		notify: self ofAllSystemChangesUsing: #announceFromEvent:! !

!SystemAnnouncer class methodsFor: 'accessing' stamp: 'lr 2/22/2010 11:14'!
methodAnnouncer
	"Answer a method annoncer."
	
	^ methodAnnouncer! !

!SystemAnnouncer class methodsFor: 'accessing' stamp: 'lr 2/22/2010 11:14'!
protocolAnnouncer
	"Answer a protocol annoncer."
	
	^ protocolAnnouncer! !

!SystemAnnouncer class methodsFor: 'initialization' stamp: 'lr 2/22/2010 11:10'!
unload
	SystemChangeNotifier uniqueInstance 
		noMoreNotificationsFor: self! !
SystemAnnouncer initialize!
